local addonName, addon = ...
local _G = _G

-- This function is first function called when everything is initialized and ready to go.
function addon.Startup()
	DoIt.Debug("Welcome to MagnetButtons "..tostring(DoIt.GetFullPlayerName())..".");
	if (DoIt.IsClassic) then
		DoIt.Debug("Notice: MagnetButtons is running in classic mode");
	end
end

--
-- This is the main start-up script, it's a one-shot, it executes itself then unsubscribes the event.
--
local startupScript = function (self, event, arg1, arg2)
	DoIt.Events:unsubscribe("PLAYER_LOGIN", startupScript);
	addon.Startup();
	addon.verifyGlobalButtonSettings()
	-- Loop through each saved button, create, and display
	for index,attributes in ipairs(MagnetButtons_ButtonData) do
		addon.MakeButton(index, attributes);
	end
	addon.OnPlayerZoneChange();
end
DoIt.Events:subscribe("PLAYER_LOGIN", startupScript);

-- Form change for druids
--DoIt.Events:subscribe("XXX", function (_, message)
	--addon.Echo("\124cffFF0000\124Hitem:19:0:0:0:0:0:0:0\124h"..tostring(message).."\124h\124r");
--end)

-- Zone Chnaged event handling	
DoIt.Events.onZoneChanged:subscribe(function ()
	addon.OnPlayerZoneChange();
end)

-- Taxi's
DoIt.Events:subscribe("TAXIMAP_CLOSED", function ()
	--addon.Echo("> "..tostring(zoneChannelId)..", "..tostring(localId)..", "..tostring(name)..", "..tostring(guid))
end)

-- Static simulated events
addon.TimeSinceLastUpdate = 0;
DoIt.Events.onUpdate:subscribe(function (elapsed)
	-- Add some delay time (Clean this up for C_Timer)
	if (not elapsed) then return end
	addon.TimeSinceLastUpdate = addon.TimeSinceLastUpdate + elapsed; 
	if (addon.TimeSinceLastUpdate < 0.2) then return end
	addon.TimeSinceLastUpdate = 0;

	-- Simulated "event" that watches for cursor pick-ups
	local type = GetCursorInfo();
	local shiftDown = IsShiftKeyDown();
	local supportedType = (type == "spell" or type == "item" or type == "petaction" or type == "macro" or type == "flyout" or type == "mount");
	if (shiftDown and supportedType and not MagnetButtonsDropTarget:IsShown()) then
		-- Cursor Pickup
		MagnetButtonsDropTarget:Show();
	elseif ((type == nil or not shiftDown) and MagnetButtonsDropTarget:IsShown()) then
		-- Cursor Drop
		addon.DraggingPetSpellIndex = nil;
		MagnetButtonsDropTarget:Hide();
	end

	-- Manage hot key bindings on a Vehicle (retail)
	local inVehicle = addon.PlayerInVehicle();
	if (addon.IsInVehicle ~= inVehicle) then
		addon.IsInVehicle = inVehicle;
		if (addon.IsInVehicle) then
			addon.DisableHotKeysBindings();
		else
			addon.EnableHotKeysBindings();
		end
	end

	-- Manage displaying or hiding the MainMenuBar
	addon.ManageMainMenuBar();

	-- Simulate events for when the flyout bar is hidden or shown
	if (SpellFlyout) then
		if (not isFlyoutBeingShown and SpellFlyout:IsShown()) then
			isFlyoutBeingShown = true;
			addon.OnFlyoutShow();
		elseif (isFlyoutBeingShown and not SpellFlyout:IsShown()) then
			isFlyoutBeingShown = false;
			addon.OnFlyoutHide();
		end
	end
end);
